QGIS Application - Bug report #11887

minimumValue() in 2.6.x for Windows different than Linux for NULL

2014-12-18 06:38 AM - Jeff Cavner

Status: Closed
Priority: Normal
Assignee:
Affected QGIS version:2.6.0
Operating System: Windows

Pull Request or Patch supplied:

Crashes QGIS or corrupls data:

Regression?:
Easy fix?:
Resolution:

No
No
up/downstream

Copied to github as #: 20101

Description

minimumValue() against the data provider or a vector layer object in Windows if a NULL value is present in the attributes for a field will
return a 0 treating the NULL as the minimum value, instead of the minimum numeric value in that field (which is my case is greater than
0). In Linux for 2.6.x it works correctly and returns the minimum numeric value and does not treat NULLs as numeric.

Associated revisions

Revision 1f8dee0lc - 2015-01-07 02:47 PM - Matthias Kuhn

Don't consider NULL values for minimumValue() and maximumValue()

Fix #11887

Revision 790916b2 - 2015-01-07 02:59 PM - Matthias Kuhn

Don't quote column names for MIN and MAX for ogrsql

See https://trac.osgeo.org/gdal/ticket/5799#comment:9

Fixes #11887

History

#1 - 2015-01-05 02:22 PM - Matthias Kuhn
- Status changed from Open to Feedback

Which data provider are you using?
Is the layer in edit mode and does it contain changes when the mistake happens?

#2 - 2015-01-05 02:45 PM - Jeff Cavner

The dataprovider from a vector layer returned from vectorLyr.dataProvider(). Also the same thing happens against just the vectorLyr, so

vectorLyr.minimumValue(index) returns the same 0.0 for a null value. The layer is not in edit mode and does not contain changes.

#3 - 2015-01-05 11:43 PM - Matthias Kuhn
https://trac.osgeo.org/gdal/ticket/5799#comment:9

And which data provider as in postgis/spatialite/ogr ...?

#4 - 2015-01-06 06:16 AM - Jeff Cavner

ogr -- shapefile

#5 - 2015-01-06 08:31 AM - Matthias Kuhn

Are the OGR versions on your Windows and Linux machine the same?

#6 - 2015-01-06 09:23 AM - Jeff Cavner

windows ogr 1.11.1

linux ogr1.9.2

#7 - 2015-01-06 02:04 PM - Matthias Kuhn

- Status changed from Feedback to Open
- Resolution set to up/downstream

Can you open an issue on their tracker?
There's a similar one open that is being fixed for GDAL/OGR 2.0
https://trac.osgeo.org/gdal/ticket/5333

#8 - 2015-01-06 02:43 PM - Jeff Cavner

Yes, just created a ticket over there. Thank you for all of the help.

#9 - 2015-01-07 01:04 AM - Jukka Rahkonen

By looking at this ESRI document http://webhelp.esri.com/arcgisdesktop/9.3/index.cfm?TopicName=Geoprocessing_considerations_for_shapefile output

NULL values in a numeric field are really stored as zeroes into the .dbf part of shapefile. And if NULL is stored as a zero into the .dbf file there is no way for

GDAL to separate it from zero that represents a real zero. | may be wrong but this ticket and the corresponding GDAL ticket feel invalid for me. But | do not

understand why Linux makes a difference for you. Could you add a shapefile with a few features and some NULLs for testing?

GDAL ticket 5333 is not related, it was about creating new functions for finding min/max/avg dates from a DATE field of a shapefile which actually a string

"CCYYMMDD" in the .dbf file.

#10 - 2015-01-07 04:47 AM - Matthias Kuhn

| can reproduce the problem on Linux with GDAL 1.11

Taking the shapefile lakes from here:

https://github.com/opengisch/QGIS-Sampledata/tree/master/shapefiles
Minimum value for the xlabel column (values 28399 and a some NULLs):

iface.activelLayer().dataProvider().minimumValue( 3 )

Editing the attriubte table and changing a NULL value to 0 works. The change can be saved and reloaded properly, so GDAL seems to be able to
distinguish 0 and NULL for shapefiles.

Upstream issue: https:/trac.0osgeo.org/gdal/ticket/5799

#11 - 2015-01-07 05:06 AM - Jukka Rahkonen

| downloaded the lakes shapefile and had a try with GDAL 2.0-dev on Windows 7 but this version does not show the issue with ogrinfo:

ogrinfo lakes.shp -sql "select min(xlabel) from lakes"
INFO: Open of ‘lakes.shp'
using driver "ESRI Shapefile' successful.

Layer name: lakes
Geometry: None
Feature Count: 1

Layer SRS WKT:
(unknown)

MIN_xlabel: Integer (8.0)

OGRFeature(lakes):0
MIN_xlabel (Integer) = 28399

#12 - 2015-01-07 05:37 AM - Matthias Kuhn

Hmmm, same result here with 1.11.1.

Debugging shows that ogr fails to interpret the sql qgis sends it (see below) and it's actually our fallback code that fails to properly handle NULL values.

QGIS debug output:

src/providers/ogr/qgsogrprovider.cpp: 2360: (minimumValue) [30361ms] Failed to execute SQL: SELECT MIN("xlabel") FROM "lakes"

ogrinfo output:
ogrinfo lakes.shp -sql 'SELECT MIN("xlabel") FROM "lakes"
INFO: Open of ‘lakes.shp'

using driver "ESRI Shapefile' successful.
ERROR 1: Argument of column Summary Function 'MIN' should be a column.

Therefore the proper question is, should we send an unquoted column name to ogr or should that be changed on gdal side?
#13 - 2015-01-07 05:53 AM - Matthias Kuhn
- Status changed from Open to Closed

Fixed in changeset commit:"1f8dee0caf7b995b1ccef41b2c92636082557da4".
